custom_maps["pear15tutorial.lua"] =
{
	character_selection = 0
}

need("multiplayer.lua")
Playlist = dofile("playlist.lua")
dofile( "config/extra.lua" )

local _LoadConfig = LoadConfig
function LoadConfig( ... )
	_LoadConfig( unpack( arg ) )
	if Game.LoadExtraConfig then
		Game.LoadExtraConfig()
	end
end

if __dbg_cur then
	__constants = constants
	constants = {}
	constants.__index = function( tab, key )
		if __constants[key] then
			return __constants[key]
		end
		Log( string.format("In %s: using a nil constant '%s'. That's probably an error, but whatever.", __dbg_cur or "some function", key) )
		return nil
	end
	setmetatable( constants, constants )
end

function _on_error()
	SwitchLighting( false )
	local paused = GamePaused()
	TogglePause( true )
	local widget1 = CreateWidget( constants.wt_Widget, "", nil, -1, -1, CONFIG.scr_width+2, CONFIG.scr_height+2 )
	WidgetSetColorBox( widget1, { 0, 0, 0, 1 } )
	WidgetSetZ( widget1, 1.09999 )
	local sx, sy = GetCaptionSize( "default", "OH SHI-" )
	local widget2 = CreateWidget( constants.wt_Label, "", widget1, CONFIG.scr_width/2 - sx, 15 + sy, 1, 1 )
	WidgetSetCaptionFont( widget2, "default", 2 )
	WidgetSetCaptionColor( widget2, { 1, .2, .2, 1 }, false )
	WidgetSetCaption( widget2, "OH SHI-" )
	WidgetSetZ( widget2, 1.09999 )
	local widget3 = CreateWidget( constants.wt_Label, "", widget1, 15, sy + 40, CONFIG.scr_width - 90, CONFIG.scr_height - sy - 100 )
	WidgetSetCaptionFont( widget3, "dialogue" )
	WidgetSetCaptionColor( widget3, { 1, 1, 1, 1 }, false )

	local crash_report = {}
	local gamename = tostring((Game or {})._game_name or "Unknown Game")
	local gameversion = tostring((Game or {})._version or "no version specified")
	table.insert( crash_report, string.format("%s %s [%s], %s build, %s (%s), %s", constants.__GAME_NAME, constants.__VERSION, constants.__ENGINE,  constants.__BUILD_TYPE, gamename, gameversion, tostring(os.date())) )
	table.insert( crash_report, string.format("built at %s, %s", constants.__BUILD_DATE, constants.__BUILD_TIME ) )
	local file
	for _, filename in pairs{ constants.path_log.."script.log", constants.path_log.."iichantra.log" } do
		file = io.open( filename, "r" )
		if file then
			file:close()
			for line in io.lines( filename ) do
				if string.match( line, "%[ERROR%]" ) or string.match( line, "%[SCRIPT%]" ) then
					table.insert( crash_report, line )
				end
			end
		else
			table.insert( crash_report, string.format("%s does not exist.", filename) )
		end
	end
	file = io.open( string.format( "crash.%s.txt", tostring(os.time()) ), "w" )
	if file then
		file:write( table.concat( crash_report, "\n" ) )
		file:close()
	else
		print( "cannot create dump" )
	end

	local intro = "/cffaaaaSomething terrible happened! A crash report has been generated in iiChantra directory. In case you are messing with the engine and this is your fault, here is some info you may find useful to fix it:/cffffff/n/n"
	local scroll = 0
	WidgetSetCaption( widget3, intro..table.concat( crash_report, "/n" ), true )
	WidgetSetCaptionScroll( widget3, 0 )
	WidgetSetZ( widget3, 1.09999 )

	local scroll_up = CreateWidget( constants.wt_Button, "", widget1, CONFIG.scr_width - 55, 15, 55, 15 )
	WidgetSetCaption( scroll_up, "UP" )
	WidgetSetLMouseClickProc( scroll_up, function()
		scroll = math.max( 0, scroll-1 )
		WidgetSetCaptionScroll( widget3, scroll )
	end )
	WidgetSetZ( scroll_up, 1.09999 )
	local scroll_down = CreateWidget( constants.wt_Button, "", widget1, CONFIG.scr_width - 55, 45, 55, 15 )
	WidgetSetCaption( scroll_down, "DOWN" )
	WidgetSetLMouseClickProc( scroll_down, function()
		scroll = scroll+1
		WidgetSetCaptionScroll( widget3, scroll )
	end )
	WidgetSetZ( scroll_down, 1.09999 )

	local exit = CreateWidget( constants.wt_Button, "", widget1, 15, CONFIG.scr_height - 35, 100, 15 )
	WidgetSetCaption( exit, "EXIT" )
	WidgetSetLMouseClickProc( exit, function() ExitGame() end )
	WidgetSetZ( exit, 1.09999 )
	local ignore = CreateWidget( constants.wt_Button, "", widget1, 115, CONFIG.scr_height - 35, 100, 15 )
	WidgetSetCaption( ignore, "IGNORE" )
	WidgetSetLMouseClickProc( ignore, function() 
		if not paused then
			TogglePause( true )
		end
		DestroyWidget( widget1 )
	end )
	WidgetSetZ( ignore, 1.09999 )
end

mapvar = {}
-- stat = {}
vars = {}
difficulty = 1

--[[
--Not-so-binary fonts.
LoadFont("font.lif", "default")
LoadFont("font-dialogue.lif", "dialogue")
--]]

LoadFont("Font.fif", "default")
LoadFont("font-dialogue.fif", "dialogue")

--need("texed/texed.lua")

